package com.yizhi.comment.application.feign;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.comment.application.vo.InformRecordVo;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.*;

@FeignClient(name = "comment", contextId = "InformRecordClient")
public interface InformRecordClient {

    @PostMapping("/remote/informRecord/save")
    public Integer save(@RequestBody InformRecordVo informRecordVo);

    @GetMapping("/remote/informRecord/getPage")
    public Page<InformRecordVo> getPage(@RequestParam("taskType") Integer taskType,
                                        @RequestParam("taskId") Long taskId,
                                        @RequestParam("type") Integer type,
                                        @RequestParam("terminalType") Integer terminalType,
                                        @RequestParam("pageNo") Integer pageNo,
                                        @RequestParam("pageSize") Integer pageSize);

    @GetMapping("/remote/informRecord/cancel")
    public Integer cancel(@RequestParam("id") Long id);

    @GetMapping("informRecord/cancelByCommentId")
    public Integer cancelByCommentId(@RequestParam("taskType") Integer taskType,
                                     @RequestParam("taskId") Long taskId,
                                     @RequestParam("type") Integer type,
                                     @RequestParam(value = "commentId",required = false) Long commentId);

//    @GetMapping("/remote/informRecord/getPersonalDataMap")
//    public Map<Long, Integer> getPersonalDataMap(@RequestParam("bizType") Integer bizType);
}
