package com.yizhi.comment.application.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
@ApiModel(value = "评论分页参数说明")
public class CommentParam {

    @ApiModelProperty(value = "业务类型 0:课程、2：论坛、 7培训项目 15专辑", required = true)
    Integer type;

    @ApiModelProperty(value = "业务Id")
    Long bizId;

    @ApiModelProperty(value = "是否只看作者 默认否")
    Boolean onlyAuthor = false;

    @ApiModelProperty(value = "关键词")
    String keyWord;

    @ApiModelProperty(value = "作者Id")
    Long author;

    @ApiModelProperty(value = "排序类型：1-最新回复  2-最早回复")
    Integer orderType;

    @ApiModelProperty(value = "评论分页参数")
    Integer pageNo = 1;

    @ApiModelProperty(value = "评论分页参数")
    Integer pageSize = 10;

    @ApiModelProperty(value = "回复列表分页参数")
    Integer replyPageNo = 1;

    @ApiModelProperty(value = "回复列表分页参数")
    Integer replyPageSize = Integer.MAX_VALUE;
}
