package com.yizhi.comment.application.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

@Data
@ApiModel(value = "PostsCommentVo", description = "带帖子信息的评论回复")
public class PostsCommentVo {

    @ApiModelProperty(value = "id")
    private Long id;

    @ApiModelProperty(value = "1:评论、2-回复")
    private Integer type;

    @ApiModelProperty(value = "账号id")
    private Long accountId;

    @ApiModelProperty(value = "评论人")
    private String commentator;

    @ApiModelProperty(value = "评论人头像")
    private String photo;

    @ApiModelProperty(value = "评论内容")
    private String content;

    @ApiModelProperty(value = "评论时间")
    private Date createTime;

    @ApiModelProperty(value = "评论时间string格式")
    private String createTimeString;

    @ApiModelProperty(value = "帖子id")
    private Long postsId;

    @ApiModelProperty(value = "帖子标题")
    private String postsTitle;

    @ApiModelProperty(value = "帖子内容")
    private String postsContent;

    @ApiModelProperty(value = "帖子封面")
    private String logo;

    @ApiModelProperty(value = "帖子是否已被删除")
    private Boolean postsHasDeleted = false;

    @ApiModelProperty(value = "帖子创建时间")
    private Date postsCreateTime;

    @ApiModelProperty(value = "被@的人用户id")
    private Long beAnswerId;

    @ApiModelProperty(value = "被@的人用户名")
    private String beAnswerName;

    @ApiModelProperty(value = "被@的人说的话")
    private String beAnswerContent;

    @ApiModelProperty(value = "被@的人是否被禁言")
    private Boolean beAnswerHasForbidden = false;

    @ApiModelProperty(value = "评论id")
    private Long commentId;

    @ApiModelProperty(value = "回复父级id 如果是回复评论,则为0")
    private Long replyParentId;

    @ApiModelProperty(value = "创建该记录的用户在该贴是否被禁言")
    private Boolean hasForbidden = false;

    @ApiModelProperty(value = "是否为当前用户创建的记录 true：是")
    private Boolean isSelf = false;

    @ApiModelProperty(value = "是否是帖子作者")
    private Boolean isAuthor = false;

    @ApiModelProperty(value = "当前回复是否被删除  true：是 ")
    private Boolean IsDeleted = false;

    @ApiModelProperty(value = "最上层的回复是否被删除了  true：是 ")
    private Boolean commentHasDeleted = false;

    @ApiModelProperty(value = "被@的人说的话是否被删除啦 true：删除")
    private Boolean beAnswerContentHasDelete = false;

    @ApiModelProperty(value = "是否已点赞 true:已点赞")
    private Boolean isAdmire = false;

    @ApiModelProperty(value = "当前回复状态")
    private Integer status;

    @ApiModelProperty(value = "当前用户是否被禁言")
    private Boolean currentHasForbidden = false;

    @ApiModelProperty(value = "评论附件")
    private List<TaskAppendixVo> taskAppendixVos;

}
