package com.yizhi.application.controller.remote;

import java.util.List;

import com.yizhi.application.domain.PdfPages;
import com.yizhi.application.mapper.PdfPagesMapper;
import org.apache.commons.collections.CollectionUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.yizhi.comment.application.vo.domain.PdfPagesVo;
import com.yizhi.application.service.IPdfPagesService;

@RestController(value = "PdfPagesControllerRemote")
@RequestMapping("/remote/pdfPages")
public class PdfPagesController {

    private static final Logger LOG = LoggerFactory.getLogger(PdfPagesController.class);

	@Autowired
	private PdfPagesMapper pdfPagesMapper;
	
	@Autowired
	private IPdfPagesService pdfPagesService;
	
	@PostMapping("/save")
	public boolean save(@RequestBody List<PdfPages> pdfPageVos) {
		try {
			if (CollectionUtils.isNotEmpty(pdfPageVos)) {
				pdfPagesMapper.deleteByBizId(pdfPageVos.get(0).getBizId(), pdfPageVos.get(0).getBizType());
				pdfPagesService.insertBatch(pdfPageVos, pdfPageVos.size());
			}
			return Boolean.TRUE;
		} catch (Exception e) {
			// TODO Auto-generated catch block
			LOG.error("pdf图片保存异常",e.getMessage());
			e.printStackTrace();
			return Boolean.FALSE;
		}
	}
	
	@GetMapping("/list")
	public List<PdfPages> list(@RequestParam("bizId")Long bizId, @RequestParam("bizType")Integer bizType){
		return pdfPagesMapper.getPages(bizId, bizType);
	}
}
