package com.yizhi.application.service.impl;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.application.domain.TaskAppendix;
import com.yizhi.message.application.constans.Constans;
import com.yizhi.core.application.context.ContextHolder;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.application.mapper.TaskAppendixMapper;
import com.yizhi.comment.application.vo.domain.TaskAppendixVo;
import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.application.service.ITaskAppendixService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.*;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author taoge123
 * @since 2020-01-16
 */
@Service
public class TaskAppendixServiceImpl extends ServiceImpl<TaskAppendixMapper, TaskAppendix> implements ITaskAppendixService {

    @Autowired
    private IdGenerator idGenerator;

    @Override
    public Integer save(Integer taskType, Long taskId, List<com.yizhi.comment.application.vo.TaskAppendixVo> taskAppendixVoVos) {
        if (CollectionUtils.isEmpty(taskAppendixVoVos)) {
            return 0;
        }
        RequestContext context = ContextHolder.get();

        List<TaskAppendix> informAppendices = new ArrayList<>(taskAppendixVoVos.size());
        taskAppendixVoVos.forEach(a -> {
            TaskAppendix taskAppendixVo = new TaskAppendix();
            BeanUtils.copyProperties(a, taskAppendixVo);
            taskAppendixVo.setId(idGenerator.generate());
            taskAppendixVo.setTaskType(taskType);
            taskAppendixVo.setTaskId(taskId);
            taskAppendixVo.setCreateById(context.getAccountId());
            taskAppendixVo.setCreateByName(context.getAccountName());
            taskAppendixVo.setCreateTime(new Date());
            informAppendices.add(taskAppendixVo);
        });
        return this.insertBatch(informAppendices) == true ? 1 : 0;
    }


    @Override
    public List<com.yizhi.comment.application.vo.TaskAppendixVo> getList(Integer taskType, Long taskId) {

        TaskAppendix taskAppendixVo = new TaskAppendix();
        taskAppendixVo.setTaskType(taskType);
        taskAppendixVo.setDeleted(Constans.NOT_DELETED);
        taskAppendixVo.setTaskId(taskId);
        EntityWrapper<TaskAppendix> wrapper = new EntityWrapper(taskAppendixVo);

        List<TaskAppendix> informAppendices = this.selectList(wrapper);
        List<com.yizhi.comment.application.vo.TaskAppendixVo> taskAppendixVoVos = null;
        if (!CollectionUtils.isEmpty(informAppendices)) {
            taskAppendixVoVos = new ArrayList<>(informAppendices.size());
            for (TaskAppendix a : informAppendices) {
                com.yizhi.comment.application.vo.TaskAppendixVo vo = new com.yizhi.comment.application.vo.TaskAppendixVo();
                BeanUtils.copyProperties(a, vo);
                taskAppendixVoVos.add(vo);
            }
        }
        return taskAppendixVoVos;
    }

    @Override
    public Map<Long, List<com.yizhi.comment.application.vo.TaskAppendixVo>> getListMap(Integer taskType, List<Long> taskIds) {
        Map<Long, List<com.yizhi.comment.application.vo.TaskAppendixVo>> map = null;
        if (!CollectionUtils.isEmpty(taskIds)) {
            map = new HashMap<>(taskIds.size());
            TaskAppendix taskAppendixVo = new TaskAppendix();
            taskAppendixVo.setTaskType(taskType);
            taskAppendixVo.setDeleted(Constans.NOT_DELETED);
            EntityWrapper<TaskAppendix> wrapper = new EntityWrapper(taskAppendixVo);
            wrapper.in("task_id", taskIds);

            List<TaskAppendix> informAppendices = this.selectList(wrapper);

            if (!CollectionUtils.isEmpty(informAppendices)) {
                for (TaskAppendix a : informAppendices) {
                    com.yizhi.comment.application.vo.TaskAppendixVo vo = new com.yizhi.comment.application.vo.TaskAppendixVo();
                    BeanUtils.copyProperties(a, vo);
                    if (map.containsKey(a.getTaskId())) {
                        List<com.yizhi.comment.application.vo.TaskAppendixVo> taskAppendixVoVos = map.get(a.getTaskId());
                        taskAppendixVoVos.add(vo);
                        map.put(a.getTaskId(), taskAppendixVoVos);
                    } else {
                        List<com.yizhi.comment.application.vo.TaskAppendixVo> taskAppendixVoVos = new ArrayList<>(informAppendices.size());
                        taskAppendixVoVos.add(vo);
                        map.put(a.getTaskId(), taskAppendixVoVos);
                    }
                }
            }
        }

        return map;
    }
}
